package at.jku.ssw.redblacktree.test;

import java.util.Arrays;
import java.util.NoSuchElementException;

import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;

import at.jku.ssw.redblacktree.impl.RedBlackTreeUtil;
import at.jku.students.redblacktree.PostOrderTreeIterator;
import at.jku.students.redblacktree.RedBlackTree;

public class PostOrderTreeIteratorTest extends IteratorTestBase {

	@Rule
	public ExpectedException thrown = ExpectedException.none();

	@Test
	public void testException() {
		RedBlackTree tree = new RedBlackTree();
		PostOrderTreeIterator it = new PostOrderTreeIterator(tree);
		assertEquals(it);
		thrown.expect(NoSuchElementException.class);
		it.next();
	}

	@Test
	public void testEmpty() {
		RedBlackTree tree = new RedBlackTree();
		assertEquals(new PostOrderTreeIterator(tree));
	}

	@Test
	public void testSingle() {
		RedBlackTree tree = new RedBlackTree();
		tree.insert('X');
		assertEquals(new PostOrderTreeIterator(tree), 'X');
	}

	@Test
	public void testTree() {
		RedBlackTree tree = new RedBlackTree();
		RedBlackTreeUtil.insertString(tree, TEST_STRING);
		char[] args = TEST_STRING.toCharArray();
		Arrays.sort(args);

		assertEquals(new PostOrderTreeIterator(tree), args);
	}

}
